# calendar - Create and manipulate a monthly calendar

## SYNOPSIS

calendar pathName ?options?

## INHERITANCE

itk::Widget <- calendar

## STANDARD OPTIONS

background | cursor | foreground |

See the "options" manual entry for details on the standard options.

## ASSOCIATED OPTIONS

int

See the "datefield" manual entry for details on this option. Note that this option is needed when the calendar is used in conjunction with the dateentry widget. It is necessary for support of international date formats in versions of Tk less than 8.4.

## WIDGET-SPECIFIC OPTIONS

    Name:                   backwardImage
    Class:                  Image
    Command-Line Switch:	-backwardimage

Specifies a image to be displayed on the backwards calendar button. This image must have been created previously with the image create command. If none is specified, a default is provided.

    Name:                   buttonForeground
    Class:                  Foreground
    Command-Line Switch:	-buttonforeground

Specifies the foreground color of the forward and backward buttons in any of the forms acceptable to Tk_GetColor. The default color is blue.

    Name:                   command
    Class:                  Command
    Command-Line Switch:	-command

Specifies a Tcl script to executed upon selection of a date in the calendar. If the command script contains any % characters, then the script will not be executed directly. Instead, a new script will be generated by replacing each %, and the character following it, with information from the calendar. The replacement depends on the character following the %, as defined in the list below.

%d

  Replaced with the date selected in the format mm/dd/yyyy.

      Name:                   currentDateFont
      Class:                  Font
      Command-Line Switch:	-currentdatefont

  Specifies the font used for the current date text in any of the forms acceptable to Tk_GetFont.

      Name:                   dateFont
      Class:                  Font
      Command-Line Switch:	-datefont

  Specifies the font used for the days of the month text in any of the forms acceptable to Tk_GetFont.

      Name:                   dayFont
      Class:                  Font
      Command-Line Switch:	-dayfont

  Specifies the font used for the days of the week text in any of the forms acceptable to Tk_GetFont.

      Name:                   days
      Class:                  days
      Command-Line Switch:	-days

  Specifies a list of values to be used for the days of the week text to displayed above the days of the month. The default value is {Su Mo Tu We Th Fr Sa}.

      Name:                   forewardImage
      Class:                  Image
      Command-Line Switch:	-forewardimage

  Specifies a image to be displayed on the forewards calendar button. This image must have been created previously with the image create command. If none is specified, a default is provided.

      Name:                   height
      Class:                  Height
      Command-Line Switch:	-height

  Specifies a desired window height that the calendar widget should request from its geometry manager. The value may be specified in any of the forms acceptable to Tk_GetPixels. The default height is 165 pixels.

      Name:                   outline
      Class:                  Outline
      Command-Line Switch:	-outline

  Specifies the outline color used to surround the days of the month text in any of the forms acceptable to Tk_GetColor. The default is the same color as the background.

      Name:                   selectColor
      Class:                  Foreground
      Command-Line Switch:	-selectcolor

  Specifies the color of the ring displayed that distinguishes the currently selected date in any of the forms acceptable to Tk_GetColor. The default is red.

      Name:                   selectThickness
      Class:                  SelectThickness
      Command-Line Switch:	-selectthickness

  Specifies the thickness of the ring displayed that distinguishes the currently selected date. The default is 3 pixels.

      Name:                   startday
      Class:                  Day
      Command-Line Switch:	-startday

  Specifies the starting day for the week: sunday, monday, tuesday, wednesday, thursday, friday, or saturday. The default is sunday.

      Name:                   titleFont
      Class:                  Font
      Command-Line Switch:	-titlefont

  Specifies the font used for the title text which consists of the month and year. The font may be given in any of the forms acceptable to Tk_GetFont.

      Name:                   weekdayBackground
      Class:                  Background
      Command-Line Switch:	-weekdaybackground

  Specifies the background color for the weekdays which allows it to be visually distinguished from the weekend. The color may be given in any of the forms acceptable to Tk_GetColor. The default is the same as the background.

      Name:                   weekendBackground
      Class:                  Background
      Command-Line Switch:	-weekendbackground

  Specifies the background color for the weekends which allows it to be visually distinguished from the weekdays. The color may be given in any of the forms acceptable to Tk_GetColor. The default is the same as the background.

      Name:                   width
      Class:                  Width
      Command-Line Switch:	-width

  Specifies a desired window width that the calendar widget should request from its geometry manager. The value may be specified in any of the forms acceptable to Tk_GetPixels. The default width is 200 pixels.

  ## DESCRIPTION

  The calendar command creates a calendar widget for the selection of a date, displaying a single month at a time. Buttons exist on the top to change the month in effect turning the pages of a calendar. As a page is turned, the dates for the month are modified. Selection of a date visually marks that date. The selected value can be monitored via the -command option or just retrieved using the get command.

  ## METHODS

  The calendar command creates a new Tcl command whose name is pathName. This command may be used to invoke various operations on the widget. It has the following general form:

      pathName option ?arg arg ...?

  Option and the args determine the exact behavior of the command. The following commands are possible for calendar widgets:

  ## WIDGET-SPECIFIC METHODS

  pathName cget option
    Returns the current value of the configuration option given by option. Option may have any of the values accepted by the calendar command.
  pathName configure ?option? ?value option value ...?
    Query or modify the configuration options of the widget. If no option is specified, returns a list describing all of the available options for pathName (see Tk_ConfigureInfo for information on the format of this list). If option is specified with no value, then the command returns a list describing the one named option (this list will be identical to the corresponding sublist of the value returned if no option is specified). If one or more option-value pairs are specified, then the command modifies the given widget option(s) to have the given value(s); in this case the command returns an empty string. Option may have any of the values accepted by the calendar command.
  pathName get ?format?
    Returns the currently selected date in a format of string or as an integer clock value using the -string and -clicks format options respectively. The default is by string. Reference the clock command for more information on obtaining dates and their formats.
  pathName select date
    Changes the currently selected date to the value specified which must be in the form of a date string, an integer clock value or as the keyword "now". Reference the clock command for more information on obtaining dates and their formats. Note that selecting a date does not change the month being shown to that of the date given. This chore is left to the show\R command.
  pathName show date
    Changes the currently displayed date to be that of the date argument which must be in the form of a date string, an integer clock value or as the keyword "now". Reference the clock command for more information on obtaining dates and their formats.

  ## COMPONENTS

      Name:                   forward
      Class:                  Button

  The forward component provides the button on the upper right of the calendar that changes the month to be the next. See the "button" widget manual entry for details on the forward component item.

      Name:                   page
      Class:                  Canvas

  The page component provides the canvas on which the title, days of the week, and days of the month appear. See the "canvas" widget manual entry for details on the page component item.

      Name:                   backward
      Class:                  Button

  The backward component provides the button on the upper right of the calendar that changes the month to be the next. See the "button" widget manual entry for details on the backward component item.

  ## EXAMPLE

       proc selectCmd {date} {
         puts $date
       }

       calendar .c -command {selectCmd %d} -weekendbackground mistyrose \\
      	-weekdaybackground ghostwhite -outline black \\
              -startday wednesday -days {We Th Fr Sa Su Mo Tu}
       pack .c

  ## AUTHORS

  Mark L. Ulferts

  Michael J. McLennan

  ## KEYWORDS

  calendar, widget